class TaskController < ApplicationController
	def index
		@editable = true
		@current_task = Task.find(:first, :conditions => ['isdone =?', 0])
		@editable = false if @current_task
		@success = Task.count(['isdone =?', 1])
		@failures = Task.count(['isdone =?', 2])
		@history = []

		ary = Task.find(:all, :conditions => ['not isdone =?', 0]).reverse
		if ary.size >= 8
			ary[0..7].each {|ar|
				x = TaskHelper::time_convert(Time.now.to_i - ar.finished)
				@history << {'state' => ar.state.value, 'body' => ar.body, 'time' => x }
			}
		else
			ary.each {|ar|
				x = TaskHelper::time_convert(Time.now.to_i - ar.finished)
				@history << {'state' => ar.state.value, 'body' => ar.body, 'time' => x }
			}
			(8 - ary.size).times { @history << {'state' => ' ', 'body' => ' ', 'time' => ' ' } }
		end
	end

	def create
		task = Task.new(params[:task])
		task.uid = 1
		task.body = params[:task][:deadline] + ' ' + task.body
		task.added = Time.now.to_i
		task.deadline = 0  # FIXME!!: obsoleted
		task.finished = 0
		task.save

		redirect_to :action => 'index'
	end

	def eval
		task = Task.find(params[:task][:id])
		task.finished = Time.now.to_i
		params.each {|key, value|
			case key
			when 'action=done'
				task.isdone = 1
			when 'action=failed'
				task.isdone = 2
			end
		}
		task.save

		redirect_to :action => 'index'
	end

	def clear
		Task.destroy_all(['uid =?', 1])

		redirect_to :action => 'index'
	end
end
